<?php

namespace FiloBlu\Flow\Model\From\Entity;

class Product extends AbstractEntity{

    public function getObjectId(){

        if(is_null($this->_objectEntityId)){
            $this->_objectEntityId = \Magento\Framework\App\ObjectManager::getInstance()->create($this->getEntityModel())->getIdBySku( $this->_entityIdentifier);
            if(empty($this->_objectEntityId)){
                $this->_objectEntityId = false;
            }
        }

        return $this->_objectEntityId;
    }

    protected function setObjectAttributeValue(){

        if(!$this->getObjectId()){
            $message = sprintf('No id found for model %s with given identifier %s',$this->getEntityModel(),$this->_entityIdentifier);
            $this->_logger->info('ITEM SKIPPED: ' . $message);
            return false;
        }

        $attribute_code = $this->getAttribute()->getAttributeCode();

        $pids = array($this->getObjectId());

        $attributesToCopy = $this->_registry->registry('attribute_configurable_copy');
        $attributesToCopyEnabled = $this->_scopeConfig->getValue('filoblu_flow/flow_process/flow_attribute_select_enabled', \Magento\Store\Model\ScopeInterface::SCOPE_STORE);

        $fatherProductsIds = $this->helper_product->getParentProductsIds($pids);

        if($attributesToCopyEnabled && !empty($fatherProductsIds) && in_array($attribute_code,$attributesToCopy)){
            $pids = array_merge($pids, $fatherProductsIds);
        }

        $attributeValue = $this->getAttributeValue();

        $attributesData = array($attribute_code => $attributeValue);
        try{
            if($attribute_code != 'sku'){
                \Magento\Framework\App\ObjectManager::getInstance()->get('Magento\Catalog\Model\Product\Action')
                    ->updateAttributes($pids, $attributesData, $this->_storeId);
            }
        }catch (\Exception $e){
            $message = "Problem while processing eavs,<br/> store id : ".$this->_storeId."<br/> pids : ".print_r($pids,true). "<br/> attribute data : ".print_r($attributesData,true);
            $message .= "<br/> \Exception : ".$e->getMessage();
            $message .= "<br/> Backtrace : <br/> ".nl2br($e->getTraceAsString());
            $this->_logger->info($message);
            throw new \Exception($e->getMessage());
        }

    }

}//End of class

